////////////////////////////////////////////////////////////////////////////////////////
//
// Nestopia - NES/Famicom emulator written in C++
//
// Copyright (C) 2003-2008 Martin Freij
//
// This file is part of Nestopia.
//
// Nestopia is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// Nestopia is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with Nestopia; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//
////////////////////////////////////////////////////////////////////////////////////////

#ifndef NST_BOARD_SXROM_H
#define NST_BOARD_SXROM_H

#ifdef NST_PRAGMA_ONCE
#pragma once
#endif

#include "NstBoardMmc1.hpp"

namespace Nes
{
	namespace Core
	{
		namespace Boards
		{
			class SxRom : public Mmc1
			{
			public:

				explicit SxRom(const Context& c)
				: Mmc1(c,c.chips.Has(L"MMC1") || c.chips.Has(L"MMC1A") ? REV_A : c.chips.Has(L"MMC1B3") ? REV_B3 : REV_B2) {}
			};
		}
	}
}

#endif
